#include <bits/stdc++.h>

using namespace std;

long long priz[75010];

int main()
{
    int t,n,m;
    cin>>t;
    while(t--)
    {
        cin>>n>>m;
        for(int i=0;i<n;i++)
        {
            cin>>priz[i];
        }
        sort(priz,priz+n);
        long long a=priz[0];
        for(int i=0;i<n-1;i++)
        {
            priz[i]=priz[i+1]-priz[i];
        }
        priz[n-1]=0;
        long long nzd=priz[0];
        for(int i=1;i<n-1;i++)
        {
            nzd=__gcd(nzd,priz[i]);
        }
        a=a%nzd;
        bool ok=true;
        long long b;
        for(int i=0;i<m;i++)
        {
            cin>>b;
            if(b%nzd==a)
            {
                ok=false;
            }

        }
        cout<<(ok?"1":"0")<<endl;
    }
}